//#line 2 "/opt/ros/one/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the opencv_apps package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __opencv_apps__EQUALIZEHISTOGRAMCONFIG_H__
#define __opencv_apps__EQUALIZEHISTOGRAMCONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace opencv_apps
{
  class EqualizeHistogramConfigStatics;

  class EqualizeHistogramConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      virtual ~AbstractParamDescription() = default;

      virtual void clamp(EqualizeHistogramConfig &config, const EqualizeHistogramConfig &max, const EqualizeHistogramConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const EqualizeHistogramConfig &config1, const EqualizeHistogramConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, EqualizeHistogramConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const EqualizeHistogramConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, EqualizeHistogramConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const EqualizeHistogramConfig &config) const = 0;
      virtual void getValue(const EqualizeHistogramConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T EqualizeHistogramConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T EqualizeHistogramConfig::* field;

      virtual void clamp(EqualizeHistogramConfig &config, const EqualizeHistogramConfig &max, const EqualizeHistogramConfig &min) const override
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const EqualizeHistogramConfig &config1, const EqualizeHistogramConfig &config2) const override
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, EqualizeHistogramConfig &config) const override
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const EqualizeHistogramConfig &config) const override
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, EqualizeHistogramConfig &config) const override
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const EqualizeHistogramConfig &config) const override
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const EqualizeHistogramConfig &config, boost::any &val) const override
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      virtual ~AbstractGroupDescription() = default;

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, EqualizeHistogramConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, EqualizeHistogramConfig &top) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const override
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T PT::* field;
      std::vector<EqualizeHistogramConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(EqualizeHistogramConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("use_camera_info"==(*_i)->name){use_camera_info = boost::any_cast<bool>(val);}
        if("histogram_equalization_type"==(*_i)->name){histogram_equalization_type = boost::any_cast<int>(val);}
        if("clahe_clip_limit"==(*_i)->name){clahe_clip_limit = boost::any_cast<double>(val);}
        if("clahe_tile_size_x"==(*_i)->name){clahe_tile_size_x = boost::any_cast<int>(val);}
        if("clahe_tile_size_y"==(*_i)->name){clahe_tile_size_y = boost::any_cast<int>(val);}
      }
    }

    bool use_camera_info;
int histogram_equalization_type;
double clahe_clip_limit;
int clahe_tile_size_x;
int clahe_tile_size_y;

    bool state;
    std::string name;

    
}groups;



//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool use_camera_info;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int histogram_equalization_type;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double clahe_clip_limit;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int clahe_tile_size_x;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int clahe_tile_size_y;
//#line 231 "/opt/ros/one/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("EqualizeHistogramConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (size_t i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (size_t i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (size_t i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (size_t i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const EqualizeHistogramConfig &__max__ = __getMax__();
      const EqualizeHistogramConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const EqualizeHistogramConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const EqualizeHistogramConfig &__getDefault__();
    static const EqualizeHistogramConfig &__getMax__();
    static const EqualizeHistogramConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const EqualizeHistogramConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void EqualizeHistogramConfig::ParamDescription<std::string>::clamp(EqualizeHistogramConfig &config, const EqualizeHistogramConfig &max, const EqualizeHistogramConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class EqualizeHistogramConfigStatics
  {
    friend class EqualizeHistogramConfig;

    EqualizeHistogramConfigStatics()
    {
EqualizeHistogramConfig::GroupDescription<EqualizeHistogramConfig::DEFAULT, EqualizeHistogramConfig> Default("Default", "", 0, 0, true, &EqualizeHistogramConfig::groups);
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.use_camera_info = 0;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.use_camera_info = 1;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.use_camera_info = 0;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<bool>("use_camera_info", "bool", 0, "Indicates that the camera_info topic should be subscribed to to get the default input_frame_id. Otherwise the frame from the image message will be used.", "", &EqualizeHistogramConfig::use_camera_info)));
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<bool>("use_camera_info", "bool", 0, "Indicates that the camera_info topic should be subscribed to to get the default input_frame_id. Otherwise the frame from the image message will be used.", "", &EqualizeHistogramConfig::use_camera_info)));
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.histogram_equalization_type = 0;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.histogram_equalization_type = 1;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.histogram_equalization_type = 0;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<int>("histogram_equalization_type", "int", 1, "Histogram Equalization Methods", "{'enum': [{'name': 'EqualizeHist', 'type': 'int', 'value': 0, 'srcline': 42, 'srcfile': '/build/package/package/cfg/EqualizeHistogram.cfg', 'description': 'Uses equalizeHist() Method', 'ctype': 'int', 'cconsttype': 'const int'}, {'name': 'Clahe', 'type': 'int', 'value': 1, 'srcline': 43, 'srcfile': '/build/package/package/cfg/EqualizeHistogram.cfg', 'description': 'Contrast Limited Adaptive Histogram Equalization', 'ctype': 'int', 'cconsttype': 'const int'}], 'enum_description': 'An Enum for histogram equaliztion methdos'}", &EqualizeHistogramConfig::histogram_equalization_type)));
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<int>("histogram_equalization_type", "int", 1, "Histogram Equalization Methods", "{'enum': [{'name': 'EqualizeHist', 'type': 'int', 'value': 0, 'srcline': 42, 'srcfile': '/build/package/package/cfg/EqualizeHistogram.cfg', 'description': 'Uses equalizeHist() Method', 'ctype': 'int', 'cconsttype': 'const int'}, {'name': 'Clahe', 'type': 'int', 'value': 1, 'srcline': 43, 'srcfile': '/build/package/package/cfg/EqualizeHistogram.cfg', 'description': 'Contrast Limited Adaptive Histogram Equalization', 'ctype': 'int', 'cconsttype': 'const int'}], 'enum_description': 'An Enum for histogram equaliztion methdos'}", &EqualizeHistogramConfig::histogram_equalization_type)));
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.clahe_clip_limit = 0.0;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.clahe_clip_limit = 255.0;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.clahe_clip_limit = 20.0;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<double>("clahe_clip_limit", "double", 2, "Clip Limit for Clahe filter", "", &EqualizeHistogramConfig::clahe_clip_limit)));
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<double>("clahe_clip_limit", "double", 2, "Clip Limit for Clahe filter", "", &EqualizeHistogramConfig::clahe_clip_limit)));
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.clahe_tile_size_x = 0;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.clahe_tile_size_x = 300;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.clahe_tile_size_x = 32;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<int>("clahe_tile_size_x", "int", 3, "X Tile Size for Clahe filter", "", &EqualizeHistogramConfig::clahe_tile_size_x)));
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<int>("clahe_tile_size_x", "int", 3, "X Tile Size for Clahe filter", "", &EqualizeHistogramConfig::clahe_tile_size_x)));
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.clahe_tile_size_y = 0;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.clahe_tile_size_y = 300;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.clahe_tile_size_y = 32;
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<int>("clahe_tile_size_y", "int", 4, "Y Tile Size for Clahe filter", "", &EqualizeHistogramConfig::clahe_tile_size_y)));
//#line 292 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EqualizeHistogramConfig::AbstractParamDescriptionConstPtr(new EqualizeHistogramConfig::ParamDescription<int>("clahe_tile_size_y", "int", 4, "Y Tile Size for Clahe filter", "", &EqualizeHistogramConfig::clahe_tile_size_y)));
//#line 247 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 247 "/opt/ros/one/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(EqualizeHistogramConfig::AbstractGroupDescriptionConstPtr(new EqualizeHistogramConfig::GroupDescription<EqualizeHistogramConfig::DEFAULT, EqualizeHistogramConfig>(Default)));
//#line 369 "/opt/ros/one/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<EqualizeHistogramConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<EqualizeHistogramConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<EqualizeHistogramConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    EqualizeHistogramConfig __max__;
    EqualizeHistogramConfig __min__;
    EqualizeHistogramConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const EqualizeHistogramConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static EqualizeHistogramConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &EqualizeHistogramConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const EqualizeHistogramConfig &EqualizeHistogramConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const EqualizeHistogramConfig &EqualizeHistogramConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const EqualizeHistogramConfig &EqualizeHistogramConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<EqualizeHistogramConfig::AbstractParamDescriptionConstPtr> &EqualizeHistogramConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<EqualizeHistogramConfig::AbstractGroupDescriptionConstPtr> &EqualizeHistogramConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const EqualizeHistogramConfigStatics *EqualizeHistogramConfig::__get_statics__()
  {
    const static EqualizeHistogramConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = EqualizeHistogramConfigStatics::get_instance();

    return statics;
  }

//#line 42 "/build/package/package/cfg/EqualizeHistogram.cfg"
      const int EqualizeHistogram_EqualizeHist = 0;
//#line 43 "/build/package/package/cfg/EqualizeHistogram.cfg"
      const int EqualizeHistogram_Clahe = 1;
}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __EQUALIZEHISTOGRAMRECONFIGURATOR_H__
